- name: Deploy Logsv2 script on devices # noqa: yaml[line-length]
  sgos.sgos_command.sgos_command:
    provider: "{{ provider }}"
    cmd: |
      bandwidth-management ;mode
      create log
      edit log ;mode
      max-bandwidth 99999
      priority 3
      exit
      exit
      ;;;;;;;;;;;;;;;;;;;;;;
      ;     LOGS FORMATS   ;
      ;;;;;;;;;;;;;;;;;;;;;;
      access-log  ;mode
      enable

      create format "Production"
      edit format Production ;mode
      type elff "cs(Client-IP) c-ip cs-username date time cs(User-Agent) cs-method c-uri cs-request-line cs(Referer) sc-status sc-bytes cs-bytes time-taken x-cs-connection-negotiated-ssl-version x-cs-connection-negotiated-cipher x-cs-connection-negotiated-cipher-strength x-cs-connection-negotiated-cipher-size s-ip"
      multi-valued-header-policy log-all-header
      exit

      create format "LOG_STATS"
      edit format LOG_STATS ;mode
      type elff "cs(Client-IP) c-ip date time time-taken cs-username cs-auth-group x-exception-id sc-filter-result cs-categories cs(Referer) sc-status s-action cs-method rs(Content-Type) cs-uri-scheme cs-host cs-uri-port cs-uri-path cs-uri-query cs-uri-extension cs(User-Agent) s-ip sc-bytes cs-bytes x-cs-http-version r-ip x-cs-connection-negotiated-ssl-version x-cs-connection-negotiated-cipher x-cs-connection-negotiated-cipher-size c-uri"
      multi-valued-header-policy log-all-header
      exit

      create format "Splunk-RPS-client-log"
      edit format Splunk-RPS-client-log
      type custom "rt=$(x-timestamp-unix-utc) dn=$(x-bluecoat-appliance-name) app=\"RPS\" xff=$(cs(Client-IP)) x_vip=$(request.x_header.X-Vip-IP) c_ip=$(c-ip) run=$(time-taken) user=$(cs-username) grp=$(cs-auth-groups) x_id=$(x-exception-id) s_action=$(s-action) status=$(sc-status) tid={{ env }} cs_B=$(cs-bytes) sc_B=$(sc-bytes) method=$(cs-method) r_host=$(cs-uri-host) r_ip=$(r-ip) r_port=$(r-port) r_path=$(cs-uri-path) resp=$(rs-time-taken) rs_status=$(rs-status) sr_B=$(sr-bytes) rs_B=$(rs-bytes) ua=\"$(cs(User-Agent))\" ext=$(cs-uri-extension) type=$(rs(Content-Type)) v=$(x-cs-http-version) filter=$(sc-filter-result) cat=$(cs-categories) s_ip=$(s-ip) dv=$(x-bluecoat-release-version) pdt=$(x-appliance-product-tag) tls=$(x-cs-connection-negotiated-ssl-version) cipher=$(x-cs-connection-negotiated-cipher) uri=$(c-uri) referrer=$(cs(Referer))"
      exit

      create format "Splunk-RPS-WAF-log"
      edit format Splunk-RPS-WAF-log
      type custom "rt=$(x-timestamp-unix-utc) dn=$(x-bluecoat-appliance-name) app=\"WAF\" xff=$(cs(Client-IP)) x_vip=$(request.x_header.X-Vip-IP) c_ip=$(c-ip) run=$(time-taken) user=$(cs-username) grp=$(cs-auth-groups) x_id=$(x-exception-id) s_action=$(s-action) status=$(sc-status) tid={{ env }} cs_B=$(cs-bytes) sc_B=$(sc-bytes) method=$(cs-method) r_host=$(cs-uri-host) r_ip=$(r-ip) r_port=$(r-port) r_path=$(cs-uri-path) resp=$(rs-time-taken) rs_status=$(rs-status) sr_B=$(sr-bytes) rs_B=$(rs-bytes) ua=\"$(cs(User-Agent))\" ext=$(cs-uri-extension) type=$(rs(Content-Type)) v=$(x-cs-http-version) filter=$(sc-filter-result) cat=$(cs-categories) s_ip=$(s-ip) dv=$(x-bluecoat-release-version) pdt=$(x-appliance-product-tag) tls=$(x-cs-connection-negotiated-ssl-version) cipher=$(x-cs-connection-negotiated-cipher) uri=$(c-uri) referrer=$(cs(Referer))"
      exit

      create format "snet_crypt_algo"
      edit format "snet_crypt_algo"
      type elff "cs(Client-IP) c-ip date time cs-method c-uri sc-status x-cs-connection-negotiated-ssl-version x-cs-connection-negotiated-cipher x-cs-connection-negotiated-cipher-strength x-cs-connection-negotiated-cipher-size"
      ; SKH ciphers
      ;type elff "cs(Client-IP) c-ip date time cs-method c-uri sc-status $(request.x_header.Cipher-Version) $(request.x_header.Cipher-Name) $(request.x_header.Cipher-Size)"
      exit

      create format "LOG_STATS_SSL"
      edit format LOG_STATS_SSL ;mode
      type elff "cs(Client-IP) c-ip date time time-taken cs-username cs-auth-group x-exception-id sc-filter-result cs-categories cs(Referer) sc-status s-action cs-method rs(Content-Type) cs-uri-scheme cs-host cs-uri-port cs-uri-path cs-uri-query cs-uri-extension cs(User-Agent) s-ip sc-bytes cs-bytes x-virus-id x-cs-http-version c-uri time-taken x-cs-connection-negotiated-ssl-version x-cs-connection-negotiated-cipher x-cs-connection-negotiated-cipher-strength x-cs-connection-negotiated-cipher-size"
      ; AMA - change 09/10/2018
      ;type elff "cs(Client-IP) c-ip date time time-taken cs-username cs-auth-group x-exception-id sc-filter-result cs-categories cs(Referer) sc-status s-action cs-method rs(Content-Type) cs-uri-scheme cs-host cs-uri-port cs-uri-path cs-uri-query cs-uri-extension cs(User-Agent) s-ip sc-bytes cs-bytes x-cs-http-version c-uri time-taken r-ip x-cs-connection-negotiated-ssl-version x-cs-connection-negotiated-cipher x-cs-connection-negotiated-cipher-size"
      multi-valued-header-policy log-all-header
      exit

      create log "main_ssl"
      edit log main_ssl ;mode
      format-name LOG_STATS
      http-client filename "SHS_MAIN_SSL_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/SHS/"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      edit log "main"
      format-name LOG_STATS
      http-client filename "MAIN_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/POOL_RAW/"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit


      create log "webgate-stats"
      edit log webgate-stats ;mode
      bandwidth-class "log"
      description "Stats for DG COMM"
      format-name LOG_STATS
      http-client filename "WEBGATE_STATS_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/EUROPA/Pool"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      exit

      create log "simap"
      edit log simap ;mode
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "SIMAP_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/STARGATE/Pool"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "bookshop"
      edit log bookshop ;mode
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "BOOKSHOP_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/STARGATE/Pool"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "eacea"
      edit log eacea ;mode
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "EACEA_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/STARGATE/Pool"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "SCIC_log_eu"
      edit log SCIC_log_eu ;mode
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "SCIC_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/EUROPA/Pool"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "Production_crypto"
      edit log "Production_crypto"
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "TESTA_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/TESTA"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      remote-size 2048
      periodic-upload upload-interval daily 1
      exit

      create log "myintracomm_acceptance"
      edit log "myintracomm_acceptance"
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "MYINTRACOMM_ACC_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/MYINTRACOMM"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "myintracomm"
      edit log "myintracomm"
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "MYINTRACOMM_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/MYINTRACOMM"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "www_cc_cec"
      edit log "www_cc_cec"
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "INTRACOMM_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/INTRACOMM"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "www_acceptance_cc_cec"
      edit log "www_acceptance_cc_cec"
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "INTRACOMM_ACC_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/INTRACOMM"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "Production"
      edit log Production ;mode
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "STARGATE_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/STARGATE"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      exit

      create log "ACC_Splunk_RPS_log"
      edit log ACC_Splunk_RPS_log
      bandwidth-class "log"
      continuous-upload enable
      continuous-upload lag-time 1
      custom-client primary {{ splunk_1 }} 1615
      format-name Splunk-RPS-client-log
      client-type custom
      upload-type text
      exit

      create log "PRD_Splunk_RPS_log"
      edit log PRD_Splunk_RPS_log
      bandwidth-class "log"
      continuous-upload enable
      continuous-upload lag-time 1
      custom-client primary {{ splunk_2 }} 1615
      format-name Splunk-RPS-client-log
      client-type custom
      upload-type text
      exit

      create log "ACC_Splunk_RPS_security_log"
      edit log ACC_Splunk_RPS_security_log
      bandwidth-class "log"
      continuous-upload enable
      continuous-upload lag-time 1
      custom-client primary {{ splunk_1 }} 1645
      format-name Splunk-RPS-WAF-log
      client-type custom
      upload-type text
      exit

      create log "PRD_Splunk_RPS_security_log"
      edit log PRD_Splunk_RPS_security_log
      bandwidth-class "log"
      continuous-upload enable
      continuous-upload lag-time 1
      custom-client primary {{ splunk_2 }} 1645
      format-name Splunk-RPS-WAF-log
      client-type custom
      upload-type text
      exit

      create log "TDM"
      edit log TDM ;mode
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "TDM_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/TDM"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "europa"
      edit log "europa"
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "EUROPA_%i_%Y%m%d%H%M%S.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/EUROPA/Pool"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "efgs_dgcg"
      edit log "efgs_dgcg"
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "EFGS_DGCG_%i_%Y%m%d%H%M%S.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/EFGS_DGCG/Pool"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "PS_503"
      edit log PS_503 ;mode
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "503_%i_%Y%m%d%H%M%S.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/503"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "loop_log"
      edit log "loop_log"
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "EUROPA_%i_%y%m%d%H%M%S.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/Loop"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "waf-logging-phase2"
      edit log waf-logging-phase2 ;mode
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "WAF.%i.%f_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/WAF"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "waf-logging-phase1"
      edit log waf-logging-phase1 ;mode
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "WAF.%i.%f_%Y%m%d%H%M.log"
      http-client primary host{{ proxy }} 443
      http-client primary path "/WAF"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "waf-tor-accesses"
      edit log waf-tor-accesses ;mode
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "WAF_%i_%Y%m%d%H%M.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/WAF"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      periodic-upload upload-interval daily 0
      exit

      create log "waf-blacklists"
      edit log waf-blacklists ;mode
      bandwidth-class "log"
      format-name LOG_STATS
      http-client filename "WAF.%i.%f_%Y%m%d%H%M%S.log"
      http-client primary host {{ proxy }} 443
      http-client primary path "/WAF"
      http-client primary username "{{ proxy_username }}"
      http-client primary password "{{ proxy_password }}"
      http-client time-format local
      http-client secure yes
      client-type http
      early-upload 200
      exit

      overflow-policy delete
      exit

  register: logs
  delegate_to: "{{ delegate_host }}"

- name: Show Script Result
  ansible.builtin.debug:
    msg: "{{ logs }}"

- name: Look for Error
  ansible.builtin.set_fact:
    check: "{{ logs | regex_search('Invalid.*\n.*') }}"

- name: Print Error
  ansible.builtin.debug:
    msg: "{{ check }}. Please check the '{{ script_path }}/{{ script }}' script in order to find the bad command !!"
  when: check
